<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="de">
<head>
<!-- Generated by javadoc (1.8.0_161) on Mon Oct 01 15:14:29 CEST 2018 -->
<title>CommandParser</title>
<meta name="date" content="2018-10-01">
<link rel="stylesheet" type="text/css" href="../../../../stylesheet.css" title="Style">
<script type="text/javascript" src="../../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="CommandParser";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":10,"i1":10,"i2":10,"i3":10,"i4":10,"i5":10};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/CommandParser.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-files/index-1.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../ch/sebi/zuul/command/CommandExecutor.html" title="interface in ch.sebi.zuul.command"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li><a href="../../../../ch/sebi/zuul/command/CommandParser.CommandElement.html" title="class in ch.sebi.zuul.command"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../index.html?ch/sebi/zuul/command/CommandParser.html" target="_top">Frames</a></li>
<li><a href="CommandParser.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li><a href="#nested.class.summary">Nested</a>&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">ch.sebi.zuul.command</div>
<h2 title="Class CommandParser" class="title">Class CommandParser</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li>java.lang.Object</li>
<li>
<ul class="inheritance">
<li>ch.sebi.zuul.command.CommandParser</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<hr>
<br>
<pre>public class <span class="typeNameLabel">CommandParser</span>
extends java.lang.Object</pre>
<div class="block">A class which parses lines in to commands and executes them</div>
<dl>
<dt><span class="simpleTagLabel">Version:</span></dt>
<dd>1.0</dd>
<dt><span class="simpleTagLabel">Author:</span></dt>
<dd>Sebastian Zumbrunn</dd>
</dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ======== NESTED CLASS SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="nested.class.summary">
<!--   -->
</a>
<h3>Nested Class Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Nested Class Summary table, listing nested classes, and an explanation">
<caption><span>Nested Classes</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Class and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>static class&nbsp;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../ch/sebi/zuul/command/CommandParser.CommandElement.html" title="class in ch.sebi.zuul.command">CommandParser.CommandElement</a></span></code>
<div class="block">An class wich contaions the command executor, the name, the syntax and the help of a command</div>
</td>
</tr>
</table>
</li>
</ul>
<!-- =========== FIELD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="field.summary">
<!--   -->
</a>
<h3>Field Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Field Summary table, listing fields, and an explanation">
<caption><span>Fields</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Field and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private java.util.HashMap&lt;java.lang.String,<a href="../../../../ch/sebi/zuul/command/CommandParser.CommandElement.html" title="class in ch.sebi.zuul.command">CommandParser.CommandElement</a>&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../ch/sebi/zuul/command/CommandParser.html#commands">commands</a></span></code>
<div class="block">A hashmap with all commands mapped to their command word</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private <a href="../../../../ch/sebi/zuul/command/Parser.html" title="class in ch.sebi.zuul.command">Parser</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../ch/sebi/zuul/command/CommandParser.html#parser">parser</a></span></code>
<div class="block">the line parser</div>
</td>
</tr>
</table>
</li>
</ul>
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Constructor Summary table, listing constructors, and an explanation">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colOne" scope="col">Constructor and Description</th>
</tr>
<tr class="altColor">
<td class="colOne"><code><span class="memberNameLink"><a href="../../../../ch/sebi/zuul/command/CommandParser.html#CommandParser-ch.sebi.zuul.command.CommandDiscoverer-ch.sebi.zuul.command.Parser-">CommandParser</a></span>(<a href="../../../../ch/sebi/zuul/command/CommandDiscoverer.html" title="class in ch.sebi.zuul.command">CommandDiscoverer</a>&nbsp;discoverer,
             <a href="../../../../ch/sebi/zuul/command/Parser.html" title="class in ch.sebi.zuul.command">Parser</a>&nbsp;parser)</code>
<div class="block">constructor</div>
</td>
</tr>
<tr class="rowColor">
<td class="colOne"><code><span class="memberNameLink"><a href="../../../../ch/sebi/zuul/command/CommandParser.html#CommandParser-ch.sebi.zuul.command.Parser-">CommandParser</a></span>(<a href="../../../../ch/sebi/zuul/command/Parser.html" title="class in ch.sebi.zuul.command">Parser</a>&nbsp;parser)</code>
<div class="block">constructor</div>
</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code><a href="../../../../ch/sebi/zuul/command/CommandParser.CommandElement.html" title="class in ch.sebi.zuul.command">CommandParser.CommandElement</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../ch/sebi/zuul/command/CommandParser.html#getCommand-java.lang.String-">getCommand</a></span>(java.lang.String&nbsp;cmd)</code>
<div class="block">Returns the command element of a command.</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code><a href="../../../../ch/sebi/zuul/command/CommandParser.CommandElement.html" title="class in ch.sebi.zuul.command">CommandParser.CommandElement</a>[]</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../ch/sebi/zuul/command/CommandParser.html#getCommands--">getCommands</a></span>()</code>
<div class="block">Returns all command elements which are reigstered in this command parser</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code><a href="../../../../ch/sebi/zuul/command/CommandExecutor.html" title="interface in ch.sebi.zuul.command">CommandExecutor</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../ch/sebi/zuul/command/CommandParser.html#getExecutor-java.lang.String-">getExecutor</a></span>(java.lang.String&nbsp;cmd)</code>
<div class="block">Returns the registered executor for the command word or null if the command doesn't exist</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code><a href="../../../../ch/sebi/zuul/command/CommandExecutor.html" title="interface in ch.sebi.zuul.command">CommandExecutor</a>[]</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../ch/sebi/zuul/command/CommandParser.html#getExecutors--">getExecutors</a></span>()</code>
<div class="block">Returns all commands which are registerd in this command parser</div>
</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../ch/sebi/zuul/command/CommandParser.html#parseNextCommand-ch.sebi.zuul.logic.Game-">parseNextCommand</a></span>(<a href="../../../../ch/sebi/zuul/logic/Game.html" title="class in ch.sebi.zuul.logic">Game</a>&nbsp;game)</code>
<div class="block">parses the next line which is returned by <a href="../../../../ch/sebi/zuul/command/Parser.html#readNextLine--"><code>Parser.readNextLine()</code></a>.</div>
</td>
</tr>
<tr id="i5" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../ch/sebi/zuul/command/CommandParser.html#registerExecutor-java.lang.String-ch.sebi.zuul.command.CommandExecutor-java.lang.String-java.lang.String-">registerExecutor</a></span>(java.lang.String&nbsp;cmd,
                <a href="../../../../ch/sebi/zuul/command/CommandExecutor.html" title="interface in ch.sebi.zuul.command">CommandExecutor</a>&nbsp;executor,
                java.lang.String&nbsp;syntax,
                java.lang.String&nbsp;help)</code>
<div class="block">Registers an executor for a command</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
<code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ FIELD DETAIL =========== -->
<ul class="blockList">
<li class="blockList"><a name="field.detail">
<!--   -->
</a>
<h3>Field Detail</h3>
<a name="parser">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>parser</h4>
<pre>private&nbsp;<a href="../../../../ch/sebi/zuul/command/Parser.html" title="class in ch.sebi.zuul.command">Parser</a> parser</pre>
<div class="block">the line parser</div>
</li>
</ul>
<a name="commands">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>commands</h4>
<pre>private&nbsp;java.util.HashMap&lt;java.lang.String,<a href="../../../../ch/sebi/zuul/command/CommandParser.CommandElement.html" title="class in ch.sebi.zuul.command">CommandParser.CommandElement</a>&gt; commands</pre>
<div class="block">A hashmap with all commands mapped to their command word</div>
</li>
</ul>
</li>
</ul>
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a name="CommandParser-ch.sebi.zuul.command.Parser-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>CommandParser</h4>
<pre>public&nbsp;CommandParser(<a href="../../../../ch/sebi/zuul/command/Parser.html" title="class in ch.sebi.zuul.command">Parser</a>&nbsp;parser)</pre>
<div class="block">constructor</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>parser</code> - the parser which should be used for parsing the lines</dd>
</dl>
</li>
</ul>
<a name="CommandParser-ch.sebi.zuul.command.CommandDiscoverer-ch.sebi.zuul.command.Parser-">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>CommandParser</h4>
<pre>public&nbsp;CommandParser(<a href="../../../../ch/sebi/zuul/command/CommandDiscoverer.html" title="class in ch.sebi.zuul.command">CommandDiscoverer</a>&nbsp;discoverer,
                     <a href="../../../../ch/sebi/zuul/command/Parser.html" title="class in ch.sebi.zuul.command">Parser</a>&nbsp;parser)</pre>
<div class="block">constructor</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>discoverer</code> - the discoveres which is used to discover the commands</dd>
<dd><code>parser</code> - the parser which should be used for parsing the lines</dd>
</dl>
</li>
</ul>
</li>
</ul>
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="parseNextCommand-ch.sebi.zuul.logic.Game-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>parseNextCommand</h4>
<pre>public&nbsp;void&nbsp;parseNextCommand(<a href="../../../../ch/sebi/zuul/logic/Game.html" title="class in ch.sebi.zuul.logic">Game</a>&nbsp;game)
                      throws java.io.IOException,
                             <a href="../../../../ch/sebi/zuul/exceptions/CommandNotFound.html" title="class in ch.sebi.zuul.exceptions">CommandNotFound</a></pre>
<div class="block">parses the next line which is returned by <a href="../../../../ch/sebi/zuul/command/Parser.html#readNextLine--"><code>Parser.readNextLine()</code></a>.<br/>
 This method blocks until the next line is found.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>game</code> - the game instance</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code>java.io.IOException</code> - if an error occurred while reading the input stream</dd>
<dd><code><a href="../../../../ch/sebi/zuul/exceptions/CommandNotFound.html" title="class in ch.sebi.zuul.exceptions">CommandNotFound</a></code></dd>
<dt><span class="seeLabel">See Also:</span></dt>
<dd><a href="../../../../ch/sebi/zuul/command/Parser.html#readNextLine--"><code>Parser.readNextLine()</code></a></dd>
</dl>
</li>
</ul>
<a name="registerExecutor-java.lang.String-ch.sebi.zuul.command.CommandExecutor-java.lang.String-java.lang.String-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>registerExecutor</h4>
<pre>public&nbsp;void&nbsp;registerExecutor(java.lang.String&nbsp;cmd,
                             <a href="../../../../ch/sebi/zuul/command/CommandExecutor.html" title="interface in ch.sebi.zuul.command">CommandExecutor</a>&nbsp;executor,
                             java.lang.String&nbsp;syntax,
                             java.lang.String&nbsp;help)</pre>
<div class="block">Registers an executor for a command</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>cmd</code> - the command word</dd>
<dd><code>executor</code> - the executor</dd>
</dl>
</li>
</ul>
<a name="getExecutor-java.lang.String-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getExecutor</h4>
<pre>public&nbsp;<a href="../../../../ch/sebi/zuul/command/CommandExecutor.html" title="interface in ch.sebi.zuul.command">CommandExecutor</a>&nbsp;getExecutor(java.lang.String&nbsp;cmd)</pre>
<div class="block">Returns the registered executor for the command word or null if the command doesn't exist</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>cmd</code> - the command word</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the executor or null</dd>
</dl>
</li>
</ul>
<a name="getCommand-java.lang.String-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getCommand</h4>
<pre>public&nbsp;<a href="../../../../ch/sebi/zuul/command/CommandParser.CommandElement.html" title="class in ch.sebi.zuul.command">CommandParser.CommandElement</a>&nbsp;getCommand(java.lang.String&nbsp;cmd)</pre>
<div class="block">Returns the command element of a command.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>cmd</code> - the command name</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the command element</dd>
</dl>
</li>
</ul>
<a name="getExecutors--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getExecutors</h4>
<pre>public&nbsp;<a href="../../../../ch/sebi/zuul/command/CommandExecutor.html" title="interface in ch.sebi.zuul.command">CommandExecutor</a>[]&nbsp;getExecutors()</pre>
<div class="block">Returns all commands which are registerd in this command parser</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>all commands known to this command parser</dd>
</dl>
</li>
</ul>
<a name="getCommands--">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>getCommands</h4>
<pre>public&nbsp;<a href="../../../../ch/sebi/zuul/command/CommandParser.CommandElement.html" title="class in ch.sebi.zuul.command">CommandParser.CommandElement</a>[]&nbsp;getCommands()</pre>
<div class="block">Returns all command elements which are reigstered in this command parser</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>all command executors</dd>
</dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/CommandParser.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-files/index-1.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../ch/sebi/zuul/command/CommandExecutor.html" title="interface in ch.sebi.zuul.command"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li><a href="../../../../ch/sebi/zuul/command/CommandParser.CommandElement.html" title="class in ch.sebi.zuul.command"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../index.html?ch/sebi/zuul/command/CommandParser.html" target="_top">Frames</a></li>
<li><a href="CommandParser.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li><a href="#nested.class.summary">Nested</a>&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
